您的位置:首页 > 其它

HDU 1074 Doing Homework(状压DP)

2017-07-17 15:58 399 查看


Doing Homework

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 9486    Accepted Submission(s): 4481


Problem Description

Ignatius has just come back school from the 30th ACM/ICPC. Now he has a lot of homework to do. Every teacher gives him a deadline of handing in the homework. If Ignatius hands in the homework after the deadline, the teacher will reduce his score of the final
test, 1 day for 1 point. And as you know, doing homework always takes a long time. So Ignatius wants you to help him to arrange the order of doing homework to minimize the reduced score.

 

Input

The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.

Each test case start with a positive integer N(1<=N<=15) which indicate the number of homework. Then N lines follow. Each line contains a string S(the subject's name, each string will at most has 100 characters) and two integers D(the deadline of the subject),
C(how many days will it take Ignatius to finish this subject's homework). 

Note: All the subject names are given in the alphabet increasing order. So you may process the problem much easier.

 

Output

For each test case, you should output the smallest total reduced score, then give out the order of the subjects, one subject in a line. If there are more than one orders, you should output the alphabet smallest one.

 

Sample Input

2
3
Computer 3 3
English 20 1
Math 3 2
3
Computer 3 3
English 6 3
Math 6 3

 

Sample Output

2
Computer
Math
English
3
Computer
English
Math

Hint
In the second test case, both Computer->English->Math and Computer->Math->English leads to reduce 3 points, but the
word "English" appears earlier than the word "Math", so we choose the first order. That is so-called alphabet order.

 

Author

Ignatius.L

 

题意:

给出每个作业的截止日期和长度,晚了截止日期几天完成就扣几分。求最小扣分。

POINT:

Nmax=15,所以用状态压缩做。题目里说了用字典序,但是它自己已经排好了,所以不用管。

#include <iostream>
#include <string.h>
#include <stdio.h>
#include <stack>
#include <algorithm>
#include <math.h>
using namespace std;
#define ll long long
struct node
{
int day;
int score;
int pre;
}dp[1<<15];
struct ode
{
string name;
int end;
int l;
}a[16];
int flag[1<<15];
void pree(int x)
{
stack<int> q;
while(x!=0)
{
q.push(x);
x=dp[x].pre;
}
int now=0;
while(!q.empty())
{
int w=now^q.top();
int wei=log(w)/log(2);
cout<<a[wei].name<<endl;
now=q.top();
q.pop();
}

}
int main()
{
int T;
scanf("%d",&T);
while(T--)
{
int n;
scanf("%d",&n);
memset(dp,0,sizeof dp);
memset(flag,0,sizeof flag);
for(int i=0;i<n;i++)
{
cin>>a[i].name>>a[i].end>>a[i].l;
}
dp[0].day=0;
dp[0].pre=-1;
dp[0].score=0;
for(int i=0;i<=(1<<n)-1;i++)
{
for(int j=0;j<n;j++)
{
if(((1<<j)&i)==1) continue;
int newi=(1<<j)|i;
int newday=dp[i].day+a[j].l;
int addscore=0;
if(newday>a[j].end)
{
addscore=newday-a[j].end;
}

int newscore=dp[i].score+addscore;
if(flag[newi])
{
if(newscore<dp[newi].score)
{
dp[newi].day=newday;
dp[newi].pre=i;
dp[newi].score=newscore;
}
}
else
{
flag[newi]=1;
dp[newi].day=newday;
dp[newi].pre=i;
dp[newi].score=newscore;
}
}
}
printf("%d\n",dp[(1<<n)-1].score);
pree((1<<n)-1);
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: